///////////////////////////////////////
/////// Topside information bar ///////
///////////////////////////////////////
void page_header() {
  // first line, vertical lines separated by the word STATS
  tft.drawFastHLine(4, 4, 23, hud_color);
  tft.setCursor(31, 0);
  tft.print("STATS"); // 5 * 6 = 30
  tft.drawFastHLine(65, 4, 23, hud_color);
  tft.drawFastHLine(92, 4, 64, hud_color);
  tft.drawFastHLine(160, 4, 64, hud_color);
  tft.drawFastHLine(228, 4, 88, hud_color);
  // second line, vertical lines separated by LVL, HP, AP and XP
  tft.drawFastVLine(4, 4, 15, hud_color);
  tft.drawFastVLine(88, 4, 15, hud_color);
  tft.drawFastVLine(156, 4, 15, hud_color);
  tft.drawFastVLine(224, 4, 15, hud_color);
  tft.drawFastVLine(316, 4, 15, hud_color);
  refreshbattery();

  tft.setCursor(92, 10);
  tft.print("TM"); // 10 * 6 = 60
  tft.setCursor(160, 10);
  tft.print("DT"); // 10 * 6 = 60
  refreshtime();
  refreshdate();
  tft.setCursor(228, 10);
  tft.print("NE"); // 14 * 6 = 84
  refreshgps();
}
//////////////////////////////////////////////
/////// end of Topside information bar ///////
//////////////////////////////////////////////

////////////////////////////////////////
////// password checking function //////
////////////////////////////////////////
void checkpass(){
  if (passwd == 0) { // login incorrect
    loginattempts++; // add 1 to loginattempts !!!
    if (loginattempts < 4) {
      page = 0;
      menu = 0;
      submenu = 0;
      beep50();
      Page_0(); // display page 0 again with the new info
    } else {
      page = 0;
      menu = 0;
      submenu = 0;
      beep1000();
      Page_99(); // display Bricked page, nothing is possible anymore...
    }
  } else { // login success
    page = 1;
    menu = 1;
    submenu = 1;
    beep50();
    Page_1(); // display page 1
  }
}
////////////////////////////////////////
////// password checking function //////
////////////////////////////////////////

////////////////////////////////////////
////// password checking function //////
////////////////////////////////////////
void checkpass2(char *a, char *b, char *c, char *d, char *e){
  if (a == "P" && b == "A" && c == "R" && d == "T" && e == "S") {
    passwd = 1;
  } else {
    passwd = 0;
  }

  tft.fillRect(255, 230, 50, 10, background_color);
  tft.setCursor(255, 231);
  tft.fillRect(255, 232, 6, 6, hud_color);
  delay(250);
  tft.fillRect(255, 232, 6, 6, background_color);
  tft.print(a);
  tft.fillRect(261, 232, 6, 6, hud_color);
  delay(250);
  tft.fillRect(261, 232, 6, 6, background_color);
  tft.print(b);
  tft.fillRect(267, 232, 6, 6, hud_color);
  delay(250);
  tft.fillRect(267, 232, 6, 6, background_color);
  tft.print(c);
  tft.fillRect(273, 232, 6, 6, hud_color);
  delay(250);
  tft.fillRect(273, 232, 6, 6, background_color);
  tft.print(d);
  tft.fillRect(279, 232, 6, 6, hud_color);
  delay(250);
  tft.fillRect(279, 232, 6, 6, background_color);
  tft.print(e);
  tft.fillRect(285, 232, 6, 6, hud_color);

  if (passwd == 0) { // login incorrect
    loginattempts++; // add 1 to loginattempts !!!
    if (loginattempts < 4) {
      page = 0;
      menu = 0;
      submenu = 0;
      beep50();
      Page_0(); // display page 0 again with the new info
    } else {
      page = 0;
      menu = 0;
      submenu = 0;
      beep1000();
      Page_99(); // display Bricked page, nothing is possible anymore...
    }
  } else { // login success
    page = 1;
    menu = 1;
    submenu = 1;
    beep50();
    Page_1(); // display page 1
  }
}
////////////////////////////////////////
////// password checking function //////
////////////////////////////////////////


////////////////////////////////////////////////////////////////////////////
////// 5 different speaker sounds (50m, 100ms, 250ms, 500ms & 1000ms) //////
////////////////////////////////////////////////////////////////////////////
void beep50(){
  if (mute == 0) {
    analogWrite(SPEAKER, 20);      // Almost any value can be used except 0 and 255
    delay(50);                      // wait for 50ms
    analogWrite(SPEAKER, 0);        // 0 turns it off
  }
}
void beep100(){
  if (mute == 0) {
    analogWrite(SPEAKER, 20);      // Almost any value can be used except 0 and 255
    delay(100);                     // wait for 100ms
    analogWrite(SPEAKER, 0);        // 0 turns it off
  }
}
void beep250(){
  if (mute == 0) {
    analogWrite(SPEAKER, 20);      // Almost any value can be used except 0 and 255
    delay(250);                     // wait for 250ms
    analogWrite(SPEAKER, 0);        // 0 turns it off
  }
}
void beep500(){
  if (mute == 0) {
    analogWrite(SPEAKER, 20);      // Almost any value can be used except 0 and 255
    delay(500);                     // wait for 500ms
    analogWrite(SPEAKER, 0);        // 0 turns it off
  }
}
void beep1000(){
  if (mute == 0) {
    analogWrite(SPEAKER, 20);      // Almost any value can be used except 0 and 255
    delay(1000);                    // wait for 1000ms
    analogWrite(SPEAKER, 0);        // 0 turns it off
  }
}
////////////////////////////////////////////////////////////////////////////
////// 5 different speaker sounds (50m, 100ms, 250ms, 500ms & 1000ms) //////
////////////////////////////////////////////////////////////////////////////

void refreshbattery(){  
  tft.fillRect(8, 10, 30, 7, background_color);
  int startpos;
  if (charging) {
    tft.drawFastVLine(9, 10, 5, hud_color);
    tft.drawFastVLine(10, 12, 5, hud_color);
    tft.drawFastVLine(11, 10, 5, hud_color);
    tft.drawFastHLine(8, 12, 5, hud_color); // 4 + 12 + 4 = 20
    tft.drawFastHLine(11, 17, 3, hud_color); // 4 + 12 + 4 = 20
    startpos = 16;
  } else {
    startpos = 8;
  }
  
  tft.drawRect(startpos, 10, 15, 7, hud_color); // battery square
  tft.drawRect((startpos + 15), 12, 2, 3, hud_color); // battery tip
  if (batterylevel > 5) {
    tft.fillRect((startpos + 2), 12, 3, 3, hud_color); // 1/3 of batt. level
  }
  if (batterylevel > 33) {
    tft.fillRect((startpos + 6), 12, 3, 3, hud_color); // 2/3 of batt. level
  }
  if (batterylevel > 66) {
    tft.fillRect((startpos + 10), 12, 3, 3, hud_color); // 3/3 of batt. level
  }




  tft.fillRect(60, 10, 24, 7, background_color);
  if (batterylevel < 10) {
    tft.setCursor(72, 10);
  } else if (batterylevel > 9 && batterylevel < 100) {
    tft.setCursor(66, 10);
  } else {
    tft.setCursor(60, 10);
  }
  tft.print(batterylevel);
  tft.print("%");
}

void refreshtime(){
  tft.setCursor(116, 10);
  tft.fillRect(116, 10, 36, 7, background_color);
  if (GPS.hour < 10) {
    tft.print("0");
    tft.print(GPS.hour, DEC);
  } else {
    tft.print(GPS.hour, DEC);
  }
  if (GPS.minute < 10) {
    tft.print("0");
    tft.print(GPS.minute, DEC);
  } else {
    tft.print(GPS.minute, DEC);
  }
  if (GPS.seconds < 10) {
    tft.print("0");
    tft.print(GPS.seconds, DEC);
  } else {
    tft.print(GPS.seconds, DEC);
  }
}
void refreshdate(){
  tft.setCursor(184, 10);
  tft.fillRect(184, 10, 36, 7, background_color);
  if (GPS.day < 10) {
    tft.print("0");
    tft.print(GPS.day, DEC);
  } else {
    tft.print(GPS.day, DEC);
  }
  if (GPS.month < 10) {
    tft.print("0");
    tft.print(GPS.month, DEC);
  } else {
    tft.print(GPS.month, DEC);
  }
  tft.print(GPS.year, DEC);
  currentday = GPS.day;
}

void refreshgps(){
  tft.setCursor(248, 10);
  tft.fillRect(248, 10, 66, 7, background_color);
  if (GPS.fix) {
    if (GPS.latitude < 10) {
      tft.print("0000");
      tft.print(GPS.latitude, 0);
    } else if (GPS.latitude > 9 && GPS.latitude < 100) {
      tft.print("000");
      tft.print(GPS.latitude, 0);
    } else if (GPS.latitude > 99 && GPS.latitude < 1000) {
      tft.print("00");
      tft.print(GPS.latitude, 0);
    } else if (GPS.latitude > 999 && GPS.latitude < 10000) {
      tft.print("0");
      tft.print(GPS.latitude, 0);
    } else {
      tft.print(GPS.latitude, 0);
    }
    tft.print("/");
    if (GPS.longitude < 10) {
      tft.print("0000");
      tft.print(GPS.longitude, 0);
    } else if (GPS.longitude > 9 && GPS.longitude < 100) {
      tft.print("000");
      tft.print(GPS.longitude, 0);
    } else if (GPS.longitude > 99 && GPS.longitude < 1000) {
        tft.print("00");
      tft.print(GPS.longitude, 0);
    } else if (GPS.longitude > 999 && GPS.longitude < 10000) {
        tft.print("0");
      tft.print(GPS.longitude, 0);
    } else {
      tft.print(GPS.longitude, 0);
    }
    gps_lat = GPS.latitude;
    gps_lon = GPS.longitude;
  } else {
    if (gps_lat > 0.0) {
      tft.setCursor(248, 10);
      tft.fillRect(248, 10, 66, 7, background_color);
      tft.print(gps_lat, 0);
      tft.print("/");
      tft.print(gps_lon, 0);
    } else {
      tft.setCursor(248, 10);
      tft.fillRect(248, 10, 66, 7, background_color);
      tft.print("31415/31415");
    }
  }
}





void bmpDraw(char* filename, int x, int y) {

  SdFile     bmpFile;
  int      bmpWidth, bmpHeight;   // W+H in pixels
  uint8_t  bmpDepth;              // Bit depth (currently must be 24)
  uint32_t bmpImageoffset;        // Start of image data in file
  uint32_t rowSize;               // Not always = bmpWidth; may have padding
  uint8_t  sdbuffer[3*BUFFPIXEL]; // pixel in buffer (R+G+B per pixel)
  uint16_t lcdbuffer[BUFFPIXEL];  // pixel out buffer (16-bit per pixel)
  uint8_t  buffidx = sizeof(sdbuffer); // Current position in sdbuffer
  boolean  goodBmp = false;       // Set to true on valid header parse
  boolean  flip    = true;        // BMP is stored bottom-to-top
  int      w, h, row, col;
  uint8_t  r, g, b;
  uint32_t pos = 0, startTime = millis();
  uint8_t  lcdidx = 0;
  boolean  first = true;

  if((x >= tft.width()) || (y >= tft.height())) return;

  Serial.println();
  progmemPrint(PSTR("Loading image '"));
  Serial.print(filename);
  Serial.println('\'');
  // Open requested file on SD card
  if (!bmpFile.open(filename, O_READ)) {
    Serial.println("File open failed.");
  } else {
    Serial.println("File opened.");
  }
// does not compile, dont know why yet
//  if ((bmpFile = SdFile.open(filename, O_READ)) == NULL) {
//    progmemPrintln(PSTR("File not found"));
//    return;
//  }


  // Parse BMP header
  if(read16(bmpFile) == 0x4D42) { // BMP signature
    progmemPrint(PSTR("File size: ")); Serial.println(read32(bmpFile));
    (void)read32(bmpFile); // Read & ignore creator bytes
    bmpImageoffset = read32(bmpFile); // Start of image data
    progmemPrint(PSTR("Image Offset: ")); Serial.println(bmpImageoffset, DEC);
    // Read DIB header
    progmemPrint(PSTR("Header size: ")); Serial.println(read32(bmpFile));
    bmpWidth  = read32(bmpFile);
    bmpHeight = read32(bmpFile);
    if(read16(bmpFile) == 1) { // # planes -- must be '1'
      bmpDepth = read16(bmpFile); // bits per pixel
      progmemPrint(PSTR("Bit Depth: ")); Serial.println(bmpDepth);
      if((bmpDepth == 24) && (read32(bmpFile) == 0)) { // 0 = uncompressed

        goodBmp = true; // Supported BMP format -- proceed!
        progmemPrint(PSTR("Image size: "));
        Serial.print(bmpWidth);
        Serial.print('x');
        Serial.println(bmpHeight);

        // BMP rows are padded (if needed) to 4-byte boundary
        rowSize = (bmpWidth * 3 + 3) & ~3;

        // If bmpHeight is negative, image is in top-down order.
        // This is not canon but has been observed in the wild.
        if(bmpHeight < 0) {
          bmpHeight = -bmpHeight;
          flip      = false;
        }

        // Crop area to be loaded
        w = bmpWidth;
        h = bmpHeight;
        if((x+w-1) >= tft.width())  w = tft.width()  - x;
        if((y+h-1) >= tft.height()) h = tft.height() - y;

        // Set TFT address window to clipped image bounds
        tft.setAddrWindow(x, y, x+w-1, y+h-1);

        for (row=0; row<h; row++) { // For each scanline...
          // Seek to start of scan line.  It might seem labor-
          // intensive to be doing this on every line, but this
          // method covers a lot of gritty details like cropping
          // and scanline padding.  Also, the seek only takes
          // place if the file position actually needs to change
          // (avoids a lot of cluster math in SD library).
          if(flip) // Bitmap is stored bottom-to-top order (normal BMP)
            pos = bmpImageoffset + (bmpHeight - 1 - row) * rowSize;
          else     // Bitmap is stored top-to-bottom
            pos = bmpImageoffset + row * rowSize;
          if(bmpFile.curPosition() != pos) { // Need seek?
            bmpFile.seekSet(pos);
            buffidx = sizeof(sdbuffer); // Force buffer reload
          }

          for (col=0; col<w; col++) { // For each column...
            // Time to read more pixel data?
            if (buffidx >= sizeof(sdbuffer)) { // Indeed
              // Push LCD buffer to the display first
              if(lcdidx > 0) {
                tft.pushColors(lcdbuffer, lcdidx, first);
                lcdidx = 0;
                first  = false;
              }
              bmpFile.read(sdbuffer, sizeof(sdbuffer));
              buffidx = 0; // Set index to beginning
            }

            // Convert pixel from BMP to TFT format
            b = sdbuffer[buffidx++];
            g = sdbuffer[buffidx++];
            r = sdbuffer[buffidx++];
            lcdbuffer[lcdidx++] = tft.color565(r,g,b);
          } // end pixel
        } // end scanline
        // Write any remaining data to LCD
        if(lcdidx > 0) {
          tft.pushColors(lcdbuffer, lcdidx, first);
        } 
        progmemPrint(PSTR("Loaded in "));
        Serial.print(millis() - startTime);
        Serial.println(" ms");
      } // end goodBmp
    }
  }
  Serial.println(read16(bmpFile), HEX);

  bmpFile.close();
  if(!goodBmp) progmemPrintln(PSTR("BMP format not recognized."));
}

// These read 16- and 32-bit types from the SD card file.
// BMP data is stored little-endian, Arduino is little-endian too.
// May need to reverse subscript order if porting elsewhere.
uint16_t read16(SdFile& f) {
  uint16_t result;
  ((uint8_t *)&result)[0] = f.read(); // LSB
  ((uint8_t *)&result)[1] = f.read(); // MSB
  return result;
}

uint32_t read32(SdFile& f) {
  uint32_t result;
  ((uint8_t *)&result)[0] = f.read(); // LSB
  ((uint8_t *)&result)[1] = f.read();
  ((uint8_t *)&result)[2] = f.read();
  ((uint8_t *)&result)[3] = f.read(); // MSB
  return result;
}

// Copy string from flash to serial port
// Source string MUST be inside a PSTR() declaration!
void progmemPrint(const char *str) {
  char c;
  while(c = pgm_read_byte(str++)) Serial.print(c);
}

// Same as above, with trailing newline
void progmemPrintln(const char *str) {
  progmemPrint(str);
  Serial.println();
}

// convert NMEA coordinate to decimal degrees
float decimalDegrees(float nmeaCoord) {
  uint16_t wholeDegrees = 0.01*nmeaCoord;
  return wholeDegrees + (nmeaCoord - 100.0*wholeDegrees)/60.0;
}

void log_gps() {
  if (GPS.fix) {
    SdFile GPSFile;
    if (!GPSFile.open("GPS_DATA.CSV", O_RDWR | O_CREAT | O_AT_END)) {
      Serial.println("GPS_DATA.CSV open failed.");
    } else {
      Serial.print("Writing to GPS_DATA.CSV...");
      GPSFile.print(GPS.hour, DEC);
      GPSFile.print(":");
      GPSFile.print(GPS.minute, DEC);
      GPSFile.print(":");
      GPSFile.print(GPS.seconds, DEC);
      GPSFile.print(",");
      GPSFile.print(GPS.day, DEC);
      GPSFile.print("/");
      GPSFile.print(GPS.month, DEC);
      GPSFile.print("/20");
      GPSFile.print(GPS.year, DEC);
      GPSFile.print(",");
      GPSFile.print(GPS.latitude, DEC);
      GPSFile.print(GPS.lat);
      GPSFile.print(",");
      GPSFile.print(GPS.longitude, DEC);
      GPSFile.print(GPS.lon);
      GPSFile.print(",");
      GPSFile.print(decimalDegrees(GPS.latitude), 5);
      GPSFile.print(",");
      GPSFile.println(decimalDegrees(GPS.longitude), 5);
      GPSFile.close();
      Serial.print("Finished writing to GPS_DATA.CSV");
    }
  }
}
