/////////////////////////
/////// MAIN LOOP ///////
/////////////////////////
void loop(void) {
  // gather GPS module data
  char c = GPS.read();
  // if you want to debug, this is a good time to do it!
  if (GPSECHO) if (c) Serial.print(c);
  // if a sentence is received, we can check the checksum, parse it...
  if (GPS.newNMEAreceived()) {
    //Serial.println(GPS.lastNMEA());   // this also sets the newNMEAreceived() flag to false
    if (!GPS.parse(GPS.lastNMEA()))   // this also sets the newNMEAreceived() flag to false
      return;  // we can fail to parse a sentence in which case we should just wait for another
  }

  // gather touch data
  Point p = ts.getPoint(); // a point p holds x y and z coordinates for touchscreen
  touchx = map(p.y, TS_MINY, TS_MAXY, 0, tft.width()); // remap y coordinates of touch to x coordinates of screen
  touchy = map(p.x, TS_MINX, TS_MAXX, tft.height(), 0); // remap y coordinates of touch to x coordinates of screen
  ////////////////////////////////////
  /////// MINPRESSURE > 0 loop ///////
  ////////////////////////////////////
  if (p.z > MINPRESSURE && p.z < MAXPRESSURE) { // require MINPRESSURE before registering it as an actual contact on the screen, 0 means no pressing

    // display normal & recalculated touch/screen coordinates to serial port: 
//     Serial.print("X = "); Serial.print(p.x); // display normal X coordinate
//     Serial.print("\tY = "); Serial.println(p.y); // display normal Y coordinate
//     Serial.print("\tPressure = "); Serial.println(p.z); // display pressure
//     Serial.print("X2 = "); Serial.print(touchx); // display recalculated Y coordinate
//     Serial.print("\tY2 = "); Serial.println(touchy); //  display recalculated Y coordinate
//     Serial.println(""); //  display recalculated Y coordinate

    ////////////////////////////////////////////
    /////// Page 0 (login) menu triggers ///////
    ////////////////////////////////////////////
    if (page == 0) {
      // INCORRECT PASSWORD 'VIRAL'
      if ((touchx > 101 && touchx < 114 && touchy > 65 && touchy < 77) || (touchx > 41 && touchx < 60 && touchy > 76 && touchy < 88)) {
        checkpass2("V", "I", "R", "A", "L");
      }
      // INCORRECT PASSWORD 'VIRAL'
      
      // INCORRECT PASSWORD 'DARED'
      if ((touchx > 95 && touchx < 114 && touchy > 87 && touchy < 99) || (touchx > 41 && touchx < 54 && touchy > 98 && touchy < 110)) {
        checkpass2("D", "A", "R", "E", "D");
      }
      // INCORRECT PASSWORD 'DARED'

      // INCORRECT PASSWORD 'WIRES'
      if ((touchx > 41 && touchx < 72 && touchy > 131 && touchy < 143)) {
        checkpass2("W", "I", "R", "E", "S");
      }
      // INCORRECT PASSWORD 'WIRES'

      // INCORRECT PASSWORD 'LINES'
      if ((touchx > 71 && touchx < 102 && touchy > 142 && touchy < 154)) {
        checkpass2("L", "I", "N", "E", "S");
      }
      // INCORRECT PASSWORD 'LINES'

      // INCORRECT PASSWORD 'LIVES'
//      if ((touchx > 53 && touchx < 84 && touchy > 153 && touchy < 165)) {
//        checkpass2("L", "I", "V", "E", "S");
//      }
      // INCORRECT PASSWORD 'LIVES'

      // INCORRECT PASSWORD 'SORTS'
//      if ((touchx > 53 && touchx < 84 && touchy > 153 && touchy < 165)) {
//        checkpass2("S", "O", "R", "T", "S");
//      }
      // INCORRECT PASSWORD 'SORTS'

      // INCORRECT PASSWORD 'AGREE'
//      if ((touchx > 53 && touchx < 84 && touchy > 153 && touchy < 165)) {
//        checkpass2("A", "G", "R", "E", "E");
//      }
      // INCORRECT PASSWORD 'AGREE'

      // INCORRECT PASSWORD 'MINES'
//      if ((touchx > 53 && touchx < 84 && touchy > 153 && touchy < 165)) {
//        checkpass2("M", "I", "N", "E", "S");
//      }
      // INCORRECT PASSWORD 'MINES'
      
      // CORRECT PASSWORD 'PARTS'
      if (touchx > 180 && touchx < 210 && touchy > 76 && touchy < 88) {
        checkpass2("P", "A", "R", "T", "S");
      }
      // CORRECT PASSWORD 'PARTS'

      // INCORRECT PASSWORD 'HAREM'
      if (touchx > 186 && touchx < 216 && touchy > 131 && touchy < 143) {
        checkpass2("H", "A", "R", "E", "M");
      }
      // INCORRECT PASSWORD 'HAREM'
    }
    ///////////////////////////////////////////////////
    /////// end of Page 0 (login) menu triggers ///////
    ///////////////////////////////////////////////////

    ////////////////////////////////////////////
    /////// Page 1 (STATS) menu triggers ///////
    ////////////////////////////////////////////
    if (page == 1) {
      // Status menu button
      if (touchx > 16 && touchx < 60 && touchy > 223 && touchy < 238) {
        page = 1;
        menu = 1;
        submenu = 1;
        delay(250);
        beep50();
        Page_1();
      }
      // Status menu button
      // S.P.E.C.I.A.L. menu button
      if (touchx > 65 && touchx < 157 && touchy > 223 && touchy < 238) {
        page = 1;
        menu = 2;
        submenu = 1;
        delay(250);
        beep50();
        Page_1();
      }
      // S.P.E.C.I.A.L. menu button
      // Skills menu button
      if (touchx > 162 && touchx < 206 && touchy > 223 && touchy < 238) {
        page = 1;
        menu = 3;
        submenu = 1;
        delay(250);
        beep50();
        Page_1();
      }
      // Skills menu button
      // Perks menu button
      if (touchx > 211 && touchx < 249 && touchy > 223 && touchy < 238) {
        page = 1;
        menu = 4;
        submenu = 1;
        delay(250);
        beep50();
        Page_1();
      }
      // Perks menu button
      // General menu button
      if (touchx > 254 && touchx < 304 && touchy > 223 && touchy < 238) {
        page = 1;
        menu = 5;
        submenu = 1;
        delay(250);
        beep50();
        Page_1();
      }
      // General menu button
      ////////////////////////////////////
      /////// Status menu triggers ///////
      ////////////////////////////////////
      if (page == 1 && menu == 1) {
        // CND submenu button
        if (touchx > 8 && touchx < 38 && touchy > 26 && touchy < 41) {
          page = 1;
          menu = 1;
          submenu = 1;
          delay(250);
          beep50();
          Page_1();
        }
        // CND submenu button
        // RAD submenu button
        if ((touchx > 8 && touchx < 38) && (touchy > 46 && touchy < 61)) {
          page = 1;
          menu = 1;
          submenu = 2;
          delay(250);
          beep50();
          Page_1();
        }
        // RAD submenu button
        // EFF submenu button
        if ((touchx > 8 && touchx < 38) && (touchy > 66 && touchy < 81)) {
          page = 1;
          menu = 1;
          submenu = 3;
          delay(250);
          beep50();
          Page_1();
        }
        // EFF submenu button
      }
      ///////////////////////////////////////////
      /////// end of Status menu triggers ///////
      ///////////////////////////////////////////
  
      ////////////////////////////////////////////
      /////// S.P.E.C.I.A.L. menu triggers ///////
      ////////////////////////////////////////////
      if (page == 1 && menu == 2) {
        // Strength submenu button
        if (touchx > 8 && touchx < 102 && touchy > 26 && touchy < 41) {
          page = 1;
          menu = 2;
          submenu = 1;
          delay(250);
          beep50();
          Page_1();
        }
        // Strength submenu button
        // Perception submenu button
        if ((touchx > 8 && touchx < 102) && (touchy > 46 && touchy < 61)) {
          page = 1;
          menu = 2;
          submenu = 2;
          delay(250);
          beep50();
          Page_1();
        }
        // Perception submenu button
        // Endurance submenu button
        if ((touchx > 8 && touchx < 102) && (touchy > 66 && touchy < 81)) {
          page = 1;
          menu = 2;
          submenu = 3;
          delay(250);
          beep50();
          Page_1();
        }
        // Endurance submenu button
        // Charisma submenu button
        if ((touchx > 8 && touchx < 102) && (touchy > 86 && touchy < 101)) {
          page = 1;
          menu = 2;
          submenu = 4;
          delay(250);
          beep50();
          Page_1();
        }
        // Charisma submenu button
        // Intelligence submenu button
        if ((touchx > 8 && touchx < 102) && (touchy > 106 && touchy < 121)) {
          page = 1;
          menu = 2;
          submenu = 5;
          delay(250);
          beep50();
          Page_1();
        }
        // Intelligence submenu button
        // Agility submenu button
        if ((touchx > 8 && touchx < 102) && (touchy > 126 && touchy < 141)) {
          page = 1;
          menu = 2;
          submenu = 6;
          delay(250);
          beep50();
          Page_1();
        }
        // Agility submenu button
        // Luck submenu button
        if ((touchx > 8 && touchx < 102) && (touchy > 146 && touchy < 161)) {
          page = 1;
          menu = 2;
          submenu = 7;
          delay(250);
          beep50();
          Page_1();
        }
        // Luck submenu button
      }
      ///////////////////////////////////////////////////
      /////// end of S.P.E.C.I.A.L. menu triggers ///////
      ///////////////////////////////////////////////////
  
  
  
      ////////////////////////////////////////////
      /////// S.P.E.C.I.A.L. menu triggers ///////
      ////////////////////////////////////////////
      if (page == 1 && menu == 5) {
        // Mute submenu button
        if (touchx > 117 && touchx < 183 && touchy > 120 && touchy < 133) {
          if (mute == 0) {
            mute = 1;
          } else {
            mute = 0;
          }
          page = 1;
          menu = 5;
          submenu = 1;
          delay(250);
          beep50();
          Page_1();
        }
        // Mute submenu button
      }
      ///////////////////////////////////////////////////
      /////// end of S.P.E.C.I.A.L. menu triggers ///////
      ///////////////////////////////////////////////////
    }
    ///////////////////////////////////////////////////
    /////// end of Page 1 (STATS) menu triggers ///////
    ///////////////////////////////////////////////////














    ////////////////////////////////////////////
    /////// Page 100 (SETTINGS) triggers ///////
    ////////////////////////////////////////////
    if (page == 100) {
      //////////////////////////////////
      /////// Mute menu triggers ///////
      //////////////////////////////////
      if (touchx > 29 && touchx < 97 && touchy > 29 && touchy < 44) {
        if (mute == 0) {
          mute = 1;
        } else {
          mute = 0;
        }
        page = 100;
        menu = 1;
        submenu = 1;
        delay(250);
        beep50();
        Page_100();
      }
      /////////////////////////////////////////
      /////// end of Mute menu triggers ///////
      /////////////////////////////////////////
      
      ////////////////////////////////////
      /////// Page 1 menu triggers ///////
      ////////////////////////////////////
      if (touchx > 29 && touchx < 73 && touchy > 49 && touchy < 64) {
        page = 1;
        menu = 1;
        submenu = 1;
        delay(250);
        beep50();
        Page_1();
      }
      ///////////////////////////////////////////
      /////// end of Page 1 menu triggers ///////
      ///////////////////////////////////////////
      
      ////////////////////////////////////
      /////// Page 2 menu triggers ///////
      ////////////////////////////////////
      if (touchx > 29 && touchx < 73 && touchy > 69 && touchy < 84) {
        page = 2;
        menu = 1;
        submenu = 1;
        delay(250);
        beep50();
        Page_2();
      }
      ///////////////////////////////////////////
      /////// end of Page 2 menu triggers ///////
      ///////////////////////////////////////////
      
      ////////////////////////////////////
      /////// Page 3 menu triggers ///////
      ////////////////////////////////////
      if (touchx > 29 && touchx < 73 && touchy > 89 && touchy < 104) {
        page = 3;
        menu = 1;
        submenu = 1;
        delay(250);
        beep50();
        Page_3();
      }
      ///////////////////////////////////////////
      /////// end of Page 3 menu triggers ///////
      ///////////////////////////////////////////



      //////////////////////////////////
      /////// HUD COLOR triggers ///////
      //////////////////////////////////
      if (touchx > 29 && touchx < 41 && touchy > 159 && touchy < 171) {
        hud_color = BLACK;
        page = 100;
        menu = 1;
        submenu = 1;
        delay(250);
        beep50();
        Page_100();
      }
      if (touchx > 44 && touchx < 56 && touchy > 159 && touchy < 171) {
        hud_color = GREEN;
        page = 100;
        menu = 1;
        submenu = 1;
        delay(250);
        beep50();
        Page_100();
      }
      if (touchx > 59 && touchx < 71 && touchy > 159 && touchy < 171) {
        hud_color = RED;
        page = 100;
        menu = 1;
        submenu = 1;
        delay(250);
        beep50();
        Page_100();
      }
      if (touchx > 74 && touchx < 86 && touchy > 159 && touchy < 171) {
        hud_color = BLUE;
        page = 100;
        menu = 1;
        submenu = 1;
        delay(250);
        beep50();
        Page_100();
      }
      if (touchx > 89 && touchx < 101 && touchy > 159 && touchy < 171) {
        hud_color = CYAN;
        page = 100;
        menu = 1;
        submenu = 1;
        delay(250);
        beep50();
        Page_100();
      }
      if (touchx > 104 && touchx < 116 && touchy > 159 && touchy < 171) {
        hud_color = MAGENTA;
        page = 100;
        menu = 1;
        submenu = 1;
        delay(250);
        beep50();
        Page_100();
      }
      if (touchx > 119 && touchx < 131 && touchy > 159 && touchy < 171) {
        hud_color = YELLOW;
        page = 100;
        menu = 1;
        submenu = 1;
        delay(250);
        beep50();
        Page_100();
      }
      if (touchx > 134 && touchx < 146 && touchy > 159 && touchy < 171) {
        hud_color = PINK;
        page = 100;
        menu = 1;
        submenu = 1;
        delay(250);
        beep50();
        Page_100();
      }
      if (touchx > 149 && touchx < 161 && touchy > 159 && touchy < 171) {
        hud_color = WHITE;
        page = 100;
        menu = 1;
        submenu = 1;
        delay(250);
        beep50();
        Page_100();
      }
      /////////////////////////////////////////
      /////// end of HUD COLOR triggers ///////
      /////////////////////////////////////////
      
      /////////////////////////////////////////
      /////// BACKGROUND COLOR triggers ///////
      /////////////////////////////////////////
      if (touchx > 29 && touchx < 41 && touchy > 189 && touchy < 201) {
        background_color = BLACK;
        page = 100;
        menu = 1;
        submenu = 1;
        delay(250);
        beep50();
        Page_100();
      }
      if (touchx > 44 && touchx < 56 && touchy > 189 && touchy < 201) {
        background_color = GREEN;
        page = 100;
        menu = 1;
        submenu = 1;
        delay(250);
        beep50();
        Page_100();
      }
      if (touchx > 59 && touchx < 71 && touchy > 189 && touchy < 201) {
        background_color = RED;
        page = 100;
        menu = 1;
        submenu = 1;
        delay(250);
        beep50();
        Page_100();
      }
      if (touchx > 74 && touchx < 86 && touchy > 189 && touchy < 201) {
        background_color = BLUE;
        page = 100;
        menu = 1;
        submenu = 1;
        delay(250);
        beep50();
        Page_100();
      }
      if (touchx > 89 && touchx < 101 && touchy > 189 && touchy < 201) {
        background_color = CYAN;
        page = 100;
        menu = 1;
        submenu = 1;
        delay(250);
        beep50();
        Page_100();
      }
      if (touchx > 104 && touchx < 116 && touchy > 189 && touchy < 201) {
        background_color = MAGENTA;
        page = 100;
        menu = 1;
        submenu = 1;
        delay(250);
        beep50();
        Page_100();
      }
      if (touchx > 119 && touchx < 131 && touchy > 189 && touchy < 201) {
        background_color = YELLOW;
        page = 100;
        menu = 1;
        submenu = 1;
        delay(250);
        beep50();
        Page_100();
      }
      if (touchx > 134 && touchx < 146 && touchy > 189 && touchy < 201) {
        background_color = PINK;
        page = 100;
        menu = 1;
        submenu = 1;
        delay(250);
        beep50();
        Page_100();
      }
      if (touchx > 149 && touchx < 161 && touchy > 189 && touchy < 201) {
        background_color = WHITE;
        page = 100;
        menu = 1;
        submenu = 1;
        delay(250);
        beep50();
        Page_100();
      }
      ////////////////////////////////////////////////
      /////// end of BACKGROUND COLOR triggers ///////
      ////////////////////////////////////////////////
    }
    ///////////////////////////////////////////////////
    /////// end of Page 100 (SETTINGS) triggers ///////
    ///////////////////////////////////////////////////
  }
  ///////////////////////////////////////////
  /////// end of MINPRESSURE > 0 loop ///////
  ///////////////////////////////////////////
  


  //////////////////////////////////////////
  /////// Page 1 RAD SENSOR triggers ///////
  //////////////////////////////////////////
  if (page == 1 && menu == 1 && submenu == 2) {
    randNumber = random(0, 1000);
    if (millicounter_1000 >= 1000) {
      if (average_counter < 3) {
        average_randNumber = average_randNumber + randNumber;
        average_counter++;
      } else {
        average_randNumber = floor(average_randNumber/3);
        int rad_arrowposition = 0;
        rad_arrowposition = map(average_randNumber, 0, 1000, 150, 300);

        tft.fillRect(151, 188, 148, 30, background_color);
        tft.fillRect(108, 197, 43, 10, background_color);
        
        tft.fillTriangle((rad_arrowposition - 4), 192, (rad_arrowposition + 4), 192, rad_arrowposition, 188, hud_color);
        tft.drawFastVLine(rad_arrowposition, 190, 15, hud_color);
        if (average_randNumber == 1000) {
            tft.setCursor((rad_arrowposition - 43), 197);
        } else if (average_randNumber < 10) {
            tft.setCursor((rad_arrowposition - 25), 197);
        } else if (average_randNumber > 99) {
            tft.setCursor((rad_arrowposition - 37), 197);
        } else {
            tft.setCursor((rad_arrowposition - 31), 197);
        }
        tft.print(average_randNumber);

        average_randNumber = 0;
        average_counter = 0;
      }
    }
  }
  /////////////////////////////////////////////////
  /////// end of Page 1 RAD SENSOR triggers ///////
  /////////////////////////////////////////////////

  //////////////////////////////////////////
  /////// Page 1 GPS SENSOR triggers ///////
  //////////////////////////////////////////
  if (page == 1 && menu == 3) {    
    if (millicounter_5000 >= 5000) {
      // display map
      bmpDraw("MAP.BMP", 70, 22);
      // draw square at current position
      recalc_lat = map((decimalDegrees(GPS.latitude) * 100), 5075, 5355, 0, 237); // remap GPS.lat.degrees to image width
      recalc_lon = map((decimalDegrees(GPS.longitude) * 100), 335, 721, 0, 200); // remap GPS.lat.degrees to image height
      recalc_lat = recalc_lat + 70; // add 70 to horizontal position for image start offset
      recalc_lon = recalc_lon + 22; // add 22 to vertical position for image start offset
      tft.drawRect((recalc_lat - 5), (recalc_lon - 5), 11, 11, hud_color); // place 11px/11px rectangle around the recalc_lat/recalc_lon intersection
      tft.drawRect(recalc_lat, recalc_lon, 1, 1, hud_color); // place 1px/1px rectangle on the recalc_lat/recalc_lon intersection
    }
    if (millicounter_1000 >= 1000) {
      tft.setRotation(4); // rotate orientation to portrait mode
      if (GPS.fix) {
        tft.setCursor(30, 255); // set cursor position
        tft.fillRect(30, 255, 100, 7, background_color); // redraw black background for text display
        tft.print("Lat: ");
        tft.print(GPS.latitude, 4);
        tft.print(GPS.lat);
        gps_lat = GPS.latitude;
        gps_lat2 = GPS.lat;
        tft.setCursor(30, 265);
        tft.fillRect(30, 265, 100, 7, background_color); // redraw black background for text display
        tft.print("Lon: ");
        tft.print(GPS.longitude, 4);
        tft.print(GPS.lon);
        gps_lon = GPS.longitude;
        gps_lon2 = GPS.lon;
        tft.fillRect(30, 275, 100, 7, background_color); // redraw black background for text display
        tft.setCursor(30, 285);
        tft.fillRect(30, 285, 100, 7, background_color); // redraw black background for text display
        tft.print("Lt");
        tft.print((char)9);        
        tft.print(": ");
        tft.print(decimalDegrees(GPS.latitude), 5);
        gps_lat_degrees = decimalDegrees(GPS.latitude);
        tft.setCursor(30, 295);
        tft.fillRect(30, 295, 100, 7, background_color); // redraw black background for text display
        tft.print("Ln");
        tft.print((char)9);        
        tft.print(": ");
        tft.print(decimalDegrees(GPS.longitude), 5);
        gps_lon_degrees = decimalDegrees(GPS.longitude);

        tft.setCursor(130, 255); // set cursor position
        tft.fillRect(130, 255, 90, 7, background_color); // redraw black background for text display
        tft.print("Spd: ");
        tft.print(GPS.speed);
        tft.setCursor(130, 265);
        tft.fillRect(130, 265, 90, 7, background_color); // redraw black background for text display
        tft.print("Ang: ");
        tft.print(GPS.angle);
        tft.setCursor(130, 275);
        tft.fillRect(130, 275, 90, 7, background_color); // redraw black background for text display
        tft.print("Alt: ");
        tft.print(GPS.altitude);
        tft.setCursor(130, 285);
        tft.fillRect(130, 285, 90, 7, background_color); // redraw black background for text display
        tft.print("Sat: ");
        tft.print(GPS.satellites);
        tft.setCursor(130, 295);
        tft.fillRect(130, 295, 90, 7, background_color); // redraw black background for text display
        tft.print("Qlt: ");
        tft.print(GPS.fixquality);    
      } else {
        tft.fillRect(30, 255, 190, 65, background_color);
        tft.setCursor(100, 255);
        tft.print("No GPS link");
        if (gps_lat > 0.0) {
          tft.setCursor(30, 275);
          tft.fillRect(30, 275, 190, 7, background_color); // redraw black background for text display
          tft.print("Last known correct location:");

          tft.setCursor(30, 285); // set cursor position
          tft.fillRect(30, 285, 100, 7, background_color); // redraw black background for text display
          tft.print("Lat: ");
          tft.print(gps_lat);
          tft.print(gps_lat2);
          tft.setCursor(30, 295);
          tft.fillRect(30, 295, 100, 7, background_color); // redraw black background for text display
          tft.print("Lon: ");
          tft.print(gps_lon);
          tft.print(gps_lon2);
        
          tft.setCursor(130, 285);
          tft.fillRect(130, 285, 90, 7, background_color); // redraw black background for text display
          tft.print("Lt");
          tft.print((char)9);        
          tft.print(": ");
          tft.print(gps_lat_degrees);
          tft.setCursor(130, 295);
          tft.fillRect(130, 295, 90, 7, background_color); // redraw black background for text display
          tft.print("Ln");
          tft.print((char)9);        
          tft.print(": ");
          tft.print(gps_lon_degrees);

        } else {
          tft.fillRect(30, 275, 190, 55, background_color);
          tft.setCursor(30, 275);
          tft.print("No last known location available");        
        }
      }
      tft.setRotation(rotation);
    }
  }
  /////////////////////////////////////////////////
  /////// end of Page 1 GPS SENSOR triggers ///////
  /////////////////////////////////////////////////

  ///////////////////////////////////////////
  /////// Page 1/2/3 battery triggers ///////
  ///////////////////////////////////////////
  if (page == 1 || page == 2 || page == 3) {
    if (millicounter_30000 >= 30000) {
      refreshbattery();
    }
  }
  //////////////////////////////////////////////////
  /////// end of Page 1/2/3 battery triggers ///////
  //////////////////////////////////////////////////
  
  /////////////////////////////////////////////////
  /////// Page 1/2/3 time/date/gps triggers ///////
  /////////////////////////////////////////////////
  if (page == 1 || page == 2 || page == 3) {
    if (millicounter_1000 >= 1000) {
      refreshtime();
      if (currentday != GPS.day) {
        refreshdate();
      }
      refreshgps();
    }
  }
  ////////////////////////////////////////////////////////
  /////// end of Page 1/2/3 time/date/gps triggers ///////
  ////////////////////////////////////////////////////////
  
  /////////////////////////////////
  /////// ANY PAGE triggers ///////
  /////////////////////////////////
  if (touchx > 309 && touchx < 321 && touchy > 0 && touchy < 11 && page != 0 && page != 99 && page != 100) {
    page = 100;
    menu = 1;
    submenu = 1;
    delay(250);
    beep50();
    Page_100();
  }

  if (millicounter_60000 >= 60000) {
    log_gps();
  }
  ////////////////////////////////////////
  /////// end of ANY PAGE triggers ///////
  ////////////////////////////////////////

  if (millicounter_1000 > 1000) {millicounter_1000 = 0;}
  if (millicounter_5000 > 5000) {millicounter_5000 = 0;}
  if (millicounter_10000 > 10000) {millicounter_10000 = 0;}
  if (millicounter_30000 > 30000) {millicounter_30000 = 0;}
  if (millicounter_60000 > 60000) {millicounter_60000 = 0;}
}
////////////////////////////////
/////// end of MAIN LOOP ///////
////////////////////////////////
